# $Id: cosa.spec,v 1.3 1999/07/09 15:04:01 kas Exp $
Summary: User-space utilities for COSA and SRP serila boards
Name: cosa
Version: 1.06
Release: 1
Source: http://www.fi.muni.cz/~kas/cosa/cosa-1.06.tar.gz
Copyright: GPL
Group: Utilities/System
Requires: initscripts >= 3.64, chkconfig
Packager: Red Hat Contrib|Net <rhcn-bugs@redhat.com>
Distribution: Red Hat Contrib|Net
ExclusiveArch: i386
BuildRoot: /var/tmp/cosa-root
Prereq: grep
Vendor: Jan "Yenya" Kasprzak <kas@fi.muni.cz>

%description
This package allows you to use the COSA and SRP synchronous serial
boards under Linux. It contains utilities for downloading firmware
to these cards, to set them up, as well as the firmware files and
various configuration files.

You will need the kernel driver to use COSA and SRP cards.
To configure the cards, look into the /etc/cosa/cosa.conf and
to the /etc/sysconfig/network-scritps/ifcfg-cosa* files.

%changelog
* Fri Jul  9 1999 Jan "Yenya" Kasprzak <kas@fi.muni.cz>
- updated to 1.06.

* Mon Feb  1 1999 Jan "Yenya" Kasprzak <kas@fi.muni.cz>
- initial RPM build.

%prep
%setup -n cosa

%build
make CFLAGS="$RPM_OPT_FLAGS" LDFLAGS=-s all

%install
test -d ${RPM_BUILD_ROOT} && rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/etc/sysconfig/network-scripts
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/init.d
mkdir -p ${RPM_BUILD_ROOT}/dev
make ROOT=${RPM_BUILD_ROOT} install-redhat
mknod ${RPM_BUILD_ROOT}/dev/cosa0c0 c 117 0
mknod ${RPM_BUILD_ROOT}/dev/cosa0c1 c 117 1
mknod ${RPM_BUILD_ROOT}/dev/cosa1c0 c 117 16
mknod ${RPM_BUILD_ROOT}/dev/cosa1c1 c 117 17
mknod ${RPM_BUILD_ROOT}/dev/cosa2c0 c 117 32
mknod ${RPM_BUILD_ROOT}/dev/cosa2c1 c 117 33
ln -s cosa0c0 ${RPM_BUILD_ROOT}/dev/cosa0
ln -s cosa1c0 ${RPM_BUILD_ROOT}/dev/cosa1
ln -s cosa1c0 ${RPM_BUILD_ROOT}/dev/cosa2

%post
if [ "$1" = 1 ]
then
	if grep -q cosa /etc/rc.d/rc.local
	then
		cat <<EOF
*****************************************************
WARNING: You seem to have the COSA startup defined in
         /etc/rc.d/rc.local.  Please comment this out
	 because COSA is now started up in its own
	 script in /etc/rc.d/init.d. Then you should
	 run "/sbin/chkconfig --add cosa" by hand.
*****************************************************
EOF
	else
		/sbin/chkconfig --add cosa
	fi
	cat <<'EOF'

You should set up the /etc/sysconfig/network-scripts/ifcfg-cosa* files
(enter IP adresses there and probably change ONBOOT=no to ONBOOT=yes),
and set up the COSA parameters in /etc/cosa/cosa.conf. And remember to
compile the kernel with COSA support (and to have the cosa.o and
syncppp.o modules installed in /lib/modules/`uname -r`/net/)

EOF
fi

%postun
if [ "$1" = 0 ]
then
	/sbin/chkconfig --del cosa
fi

%files
%attr(0755,root,root) %dir /etc/cosa
%attr(0755,root,root) /etc/cosa/srctl
%attr(0755,root,root) /etc/cosa/par2hex
%attr(0644,root,root) /etc/cosa/*.hex
%attr(0644,root,root) /etc/cosa/*.com
%attr(0755,root,root) /etc/cosa/rc.cosa
%attr(0755,root,root) %config /etc/cosa/cosa.conf
%attr(0755,root,root) %config /etc/sysconfig/network-scripts/ifcfg-cosa*
%attr(0755,root,root) /etc/sysconfig/network-scripts/ifup-cosa
%attr(-,root,root) /etc/sysconfig/network-scripts/ifup-cosa?*
%attr(-,root,root) /etc/rc.d/init.d/cosa
%attr(0640,root,tty) /dev/cosa0c0
%attr(0640,root,tty) /dev/cosa0c1
%attr(0640,root,tty) /dev/cosa1c0
%attr(0640,root,tty) /dev/cosa1c1
%attr(0640,root,tty) /dev/cosa2c0
%attr(0640,root,tty) /dev/cosa2c1
%attr(-,root,root) /dev/cosa0
%attr(-,root,root) /dev/cosa1
%attr(-,root,root) /dev/cosa2
