/* $Id: par2hex.c,v 1.4 1998/12/01 12:50:37 kas Exp $ */

/*
 * Originally written for *BSD by Zdenek Salvet and Ivos Cernohlavek.
 * Ported to Linux by Jan "Yenya" Kasprzak <kas@fi.muni.cz>
 */

#ifdef NETBSD
#include <machine/endian.h>
#else
#include <netinet/in.h>
#endif
#include <string.h>
#include <stdio.h>

#define NCHANNELS 2
#define START_ADDR "0402"
#define DEFAULT_SPEED "64kb"

char *speeds[]={"32kb","64kb","128kb","256kb","512kb","1Mb","1.8Mb","2.3Mb","3Mb","4.5Mb","9Mb"};
short coeffs[]={ 277, 143, 71, 35, 17, 8, 4, 3, 2, 1 ,0 };

int rxclock[NCHANNELS+1];
int txclock[NCHANNELS+1];
short txspeed[NCHANNELS+1];

static void chyba(char *mess)
{ fprintf(stderr,"par2hex: %s\n",mess);
  exit(1);
}

int main(int argc,char *argv[])
{

int i,j;
char *pom;
int channel;
short default_speed;

if (argc==1) chyba(" usage: channel X speed {rxint,txint,rxext,txext}\n\t\t\trxint&txext is invalid");

pom=DEFAULT_SPEED;
for (j=0;j<sizeof(speeds)/sizeof(char*);j++) if (!strcmp(pom,speeds[j])) break;
if (j<sizeof(speeds)/sizeof(char*)) default_speed=coeffs[j];
for (j=1;j<=NCHANNELS;j++) txspeed[j]=default_speed;

for (i=1;i<argc;i++)
{  pom=argv[i];
   if (!strncmp("chan",pom,4))
         { if ((channel=atoi(argv[++i]))< 1 || channel>NCHANNELS) chyba("invalid channel number"); }
   else if (!strcmp("div",pom))
         { (txspeed[channel]=atoi(argv[++i])); }
   else if (!strcmp("rxint",pom)) rxclock[channel]=1;
   else if (!strcmp("rxext",pom)) rxclock[channel]=0;
   else if (!strcmp("txint",pom)) txclock[channel]=1;
   else if (!strcmp("txext",pom)) txclock[channel]=0;
   else 
     { for (j=0;j<sizeof(speeds)/sizeof(char*);j++) if (!strcasecmp(pom,speeds[j])) break;
       if (j<sizeof(speeds)/sizeof(char*)) txspeed[channel]=coeffs[j];
          else chyba("unknown parameter");
     }
}

printf(":06" START_ADDR "00");
printf("%02X",((txclock[1]? 1+ rxclock[1]*4 : 0 ) +
             (txclock[2]? 2+ rxclock[2]*8  : 0 )));
printf("00");
printf("%04X%04X",htons(txspeed[1]),htons(txspeed[2]));
printf("00\r\n");
printf(":00000001FF\r\n");

return 0;
}

